#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D u_texture;

void main()
{
	float offset = 0.002;

	gl_FragColor = v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x - offset, v_texCoord.y - offset));
	gl_FragColor += v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y - offset));
	gl_FragColor += v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x + offset, v_texCoord.y - offset));

	gl_FragColor += v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x - offset, v_texCoord.y));
	gl_FragColor += v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y));
	gl_FragColor += v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x + offset, v_texCoord.y));

	gl_FragColor += v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x - offset, v_texCoord.y + offset));
	gl_FragColor += v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y + offset));
	gl_FragColor += v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x + offset, v_texCoord.y + offset));

	gl_FragColor.rgb *= 0.8 * 0.33 * 0.33;
	gl_FragColor.a = 1.0;
}
