#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform vec4 u_fillColor;
uniform vec4 u_glowColor;

void main()
{
	float fillAlpha = ceil(texture2D(u_texture, v_texCoord).a);

	float radius = 0.03;
	float alpha = 0.6 * ceil(max(max(max(max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.1), v_texCoord.y + radius * sin(6.28 * 0.1))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.2), v_texCoord.y + radius * sin(6.28 * 0.2))).a), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.3), v_texCoord.y + radius * sin(6.28 * 0.3))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.4), v_texCoord.y + radius * sin(6.28 * 0.4))).a)), max(max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.5), v_texCoord.y + radius * sin(6.28 * 0.5))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.6), v_texCoord.y + radius * sin(6.28 * 0.6))).a), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.7), v_texCoord.y + radius * sin(6.28 * 0.7))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.8), v_texCoord.y + radius * sin(6.28 * 0.8))).a))), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.9), v_texCoord.y + radius * sin(6.28 * 0.9))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 1.0), v_texCoord.y + radius * sin(6.28 * 1.0))).a)));

	radius = 0.06;
	alpha = alpha + (1.0 - ceil(alpha)) * 0.5 * ceil(max(max(max(max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.1), v_texCoord.y + radius * sin(6.28 * 0.1))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.2), v_texCoord.y + radius * sin(6.28 * 0.2))).a), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.3), v_texCoord.y + radius * sin(6.28 * 0.3))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.4), v_texCoord.y + radius * sin(6.28 * 0.4))).a)), max(max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.5), v_texCoord.y + radius * sin(6.28 * 0.5))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.6), v_texCoord.y + radius * sin(6.28 * 0.6))).a), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.7), v_texCoord.y + radius * sin(6.28 * 0.7))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.8), v_texCoord.y + radius * sin(6.28 * 0.8))).a))), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.9), v_texCoord.y + radius * sin(6.28 * 0.9))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 1.0), v_texCoord.y + radius * sin(6.28 * 1.0))).a)));

	radius = 0.09;
	alpha = alpha + (1.0 - ceil(alpha)) * 0.35 * ceil(max(max(max(max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.1), v_texCoord.y + radius * sin(6.28 * 0.1))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.2), v_texCoord.y + radius * sin(6.28 * 0.2))).a), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.3), v_texCoord.y + radius * sin(6.28 * 0.3))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.4), v_texCoord.y + radius * sin(6.28 * 0.4))).a)), max(max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.5), v_texCoord.y + radius * sin(6.28 * 0.5))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.6), v_texCoord.y + radius * sin(6.28 * 0.6))).a), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.7), v_texCoord.y + radius * sin(6.28 * 0.7))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.8), v_texCoord.y + radius * sin(6.28 * 0.8))).a))), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.9), v_texCoord.y + radius * sin(6.28 * 0.9))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 1.0), v_texCoord.y + radius * sin(6.28 * 1.0))).a)));

	radius = 0.12;
	alpha = alpha + (1.0 - ceil(alpha)) * 0.2 * ceil(max(max(max(max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.1), v_texCoord.y + radius * sin(6.28 * 0.1))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.2), v_texCoord.y + radius * sin(6.28 * 0.2))).a), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.3), v_texCoord.y + radius * sin(6.28 * 0.3))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.4), v_texCoord.y + radius * sin(6.28 * 0.4))).a)), max(max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.5), v_texCoord.y + radius * sin(6.28 * 0.5))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.6), v_texCoord.y + radius * sin(6.28 * 0.6))).a), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.7), v_texCoord.y + radius * sin(6.28 * 0.7))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.8), v_texCoord.y + radius * sin(6.28 * 0.8))).a))), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.9), v_texCoord.y + radius * sin(6.28 * 0.9))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 1.0), v_texCoord.y + radius * sin(6.28 * 1.0))).a)));

	radius = 0.15;
	alpha = alpha + (1.0 - ceil(alpha)) * 0.1 * ceil(max(max(max(max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.1), v_texCoord.y + radius * sin(6.28 * 0.1))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.2), v_texCoord.y + radius * sin(6.28 * 0.2))).a), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.3), v_texCoord.y + radius * sin(6.28 * 0.3))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.4), v_texCoord.y + radius * sin(6.28 * 0.4))).a)), max(max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.5), v_texCoord.y + radius * sin(6.28 * 0.5))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.6), v_texCoord.y + radius * sin(6.28 * 0.6))).a), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.7), v_texCoord.y + radius * sin(6.28 * 0.7))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.8), v_texCoord.y + radius * sin(6.28 * 0.8))).a))), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.9), v_texCoord.y + radius * sin(6.28 * 0.9))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 1.0), v_texCoord.y + radius * sin(6.28 * 1.0))).a)));

	radius = 0.18;
	alpha = alpha + (1.0 - ceil(alpha)) * 0.05 * ceil(max(max(max(max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.1), v_texCoord.y + radius * sin(6.28 * 0.1))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.2), v_texCoord.y + radius * sin(6.28 * 0.2))).a), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.3), v_texCoord.y + radius * sin(6.28 * 0.3))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.4), v_texCoord.y + radius * sin(6.28 * 0.4))).a)), max(max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.5), v_texCoord.y + radius * sin(6.28 * 0.5))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.6), v_texCoord.y + radius * sin(6.28 * 0.6))).a), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.7), v_texCoord.y + radius * sin(6.28 * 0.7))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.8), v_texCoord.y + radius * sin(6.28 * 0.8))).a))), max(texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 0.9), v_texCoord.y + radius * sin(6.28 * 0.9))).a, texture2D(u_texture, vec2(v_texCoord.x + radius * cos(6.28 * 1.0), v_texCoord.y + radius * sin(6.28 * 1.0))).a)));

	alpha *= 1.0 - ceil(fillAlpha);
	gl_FragColor = v_fragmentColor * (u_fillColor * fillAlpha + u_glowColor * alpha);
}
