precision mediump float;

varying vec4 v_fragmentColor;
varying vec2 v_fog_texCoord;
uniform sampler2D u_fog_texture;

void main()
{
	gl_FragColor = texture2D(u_fog_texture, v_fog_texCoord);

    gl_FragColor.rg *= 0.47 * v_fragmentColor.a;
    gl_FragColor.b *= 0.5 * v_fragmentColor.a;
    gl_FragColor.a *= v_fragmentColor.a;
}
