#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform float u_gradientAlpha;

void main()
{
	gl_FragColor = texture2D(u_texture, v_texCoord) * v_fragmentColor.a;
        gl_FragColor.rgb = (gl_FragColor.rgb * (1.0 - u_gradientAlpha) + v_fragmentColor.rgb * (u_gradientAlpha)) * gl_FragColor.a;
}
