#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform vec4 u_color;
uniform vec4 u_tint;
uniform vec4 u_skinColorAndBlend;
uniform float u_alpha_value;

void main()
{
    gl_FragColor = v_fragmentColor * texture2D(u_texture, v_texCoord);
    gl_FragColor.rgb = 1.3 * gl_FragColor.r * u_skinColorAndBlend.rgb;
    gl_FragColor.rgb = (gl_FragColor.rgb * (1.0 - u_color.a) + u_color.rgb * u_color.a * gl_FragColor.a) * (1.0 - u_tint.a) + u_tint.rgb * u_tint.a * gl_FragColor.a;
}
