#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform vec4 u_color;
uniform vec4 u_tint;
uniform vec4 u_skinColorAndBlend;
uniform float u_alpha_value;

void main()
{
    gl_FragColor = u_skinColorAndBlend * texture2D(u_texture, v_texCoord).a;

    if (gl_FragColor.a < u_alpha_value) {
        discard;
    }
}
