#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform float u_progress;

void main()
{
	if (3.14 + atan(v_texCoord.y - 0.5, v_texCoord.x - 0.5) < 6.28 * u_progress) {
	   gl_FragColor = vec4(0.0, 0.0, 0.0, 0.0);
	} else {
	   gl_FragColor = v_fragmentColor * texture2D(u_texture, v_texCoord);
	}
}
