#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform sampler2D u_shiny;
uniform float u_time;

void main()
{
    vec4 texture = texture2D( u_texture, v_texCoord );
    vec2 v_texCoordShiny = vec2( v_texCoord.x, v_texCoord.y - u_time);
    vec4 shiny = texture2D( u_shiny, v_texCoordShiny );
    vec4 final = shiny;
    gl_FragColor = v_fragmentColor * final * texture.a;
}
