#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D u_texture;

void main()
{
	float offset = 0.0015;

	gl_FragColor = 0.3 * v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y));

	gl_FragColor += 0.22 * v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y - offset));
	gl_FragColor += 0.22 * v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y + offset));

	gl_FragColor += 0.13 * v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y - 2.0 * offset));
	gl_FragColor += 0.13 * v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y + 2.0 * offset));
}
