#ifdef GL_ES
precision mediump float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D u_texture;

void main()
{
        float offset = 0.003;

	gl_FragColor = 0.12 * v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y));

	gl_FragColor += 0.11 * v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x - offset, v_texCoord.y - offset));
	gl_FragColor += 0.11 * v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y - offset));
	gl_FragColor += 0.11 * v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x + offset, v_texCoord.y - offset));

	gl_FragColor += 0.11 * v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x - offset, v_texCoord.y));
	gl_FragColor += 0.11 * v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x + offset, v_texCoord.y));

	gl_FragColor += 0.11 * v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x - offset, v_texCoord.y + offset));
	gl_FragColor += 0.11 * v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y + offset));
	gl_FragColor += 0.11 * v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x + offset, v_texCoord.y + offset));

	gl_FragColor.rgb *= 0.8;
}
