attribute vec4 a_position;
attribute vec2 a_texCoord;
attribute vec4 a_color;

uniform mat4 u_MVPMatrix;

uniform vec2 u_fog_anim_delta;
uniform vec2 u_parallax_anim_delta;

varying lowp vec4 v_fragmentColor;
varying mediump vec2 v_fog_texCoord;
varying mediump vec2 v_parallax_texCoord;

void main()
{
    gl_Position = u_MVPMatrix * a_position;

    v_fragmentColor = a_color;
    v_fog_texCoord = a_texCoord - u_fog_anim_delta;
    v_parallax_texCoord = a_texCoord - u_parallax_anim_delta;
}