precision mediump float;

varying vec4 v_fragmentColor;
varying vec2 v_fog_texCoord;
uniform sampler2D u_fog_texture;

void main()
{
    vec4 fog_color = texture2D(u_fog_texture, v_fog_texCoord);

    vec4 frag_color = fog_color * v_fragmentColor;
    frag_color.rgb *= v_fragmentColor.a;

    gl_FragColor = frag_color;
}
