#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D u_texture;

void main()
{
	float offset = 1.0 - max(abs(v_texCoord.y - 0.35) - 0.1, 0.0);
	gl_FragColor = v_fragmentColor * texture2D(u_texture, vec2(v_texCoord.x, v_texCoord.y));
	gl_FragColor.rgb *= offset;
}
