#ifdef GL_ES
precision lowp float;
#endif

varying vec4 v_fragmentColor;
varying vec2 v_texCoord;
uniform sampler2D u_texture;
uniform vec4 u_tint;

void main()
{
    gl_FragColor = v_fragmentColor * texture2D(u_texture, v_texCoord);
    gl_FragColor.rgb = gl_FragColor.rgb * (1.0 - u_tint.a) + u_tint.rgb * u_tint.a * gl_FragColor.a;
}
